CREATE OR REPLACE PACKAGE EXCEPTION_PKG AS
  PROCEDURE GEST_EX (p_cError IN INT, p_nProc IN VARCHAR2, p_params VARCHAR2, p_msg OUT VARCHAR2);
END EXCEPTION_PKG;
/

CREATE OR REPLACE PACKAGE BODY EXCEPTION_PKG AS
  PROCEDURE GEST_EX (p_cError IN INT, p_nProc IN VARCHAR2, p_params VARCHAR2, p_msg OUT VARCHAR2) IS
    logREG INT;
  BEGIN
    SELECT valor INTO p_msg FROM AUX_ERR_MISSATGES WHERE idMissatge=p_cError;
    ROLLBACK;
    logREG:=LOG_PKG.registrar_log(p_nProc, p_params, p_cError);
    dbms_output.put_line(p_cError||'--'||p_msg);
  END;
END EXCEPTION_PKG;