declare
	p_RES int;
	p_ERRDESC VARCHAR2(150);
  CURSOR cbotigues IS SELECT idBotiga FROM BOTIGA;
  CURSOR cproductes IS SELECT idProducte FROM PRODUCTE;
  botiga NUMBER;
  producte NUMBER;
  hora NUMBER;
  dataV DATE;
  hora INT;
  rand NUMBER;
  nArt NUMBER;
  preu NUMBER;
  benefici NUMBER;
begin

--Desactivem els triggers...
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST DISABLE';

DELETE FROM ESTADISTICA;
DELETE FROM EST_BOTIGA;
DELETE FROM EST_CIUTAT;
DELETE FROM EST_DIA;
DELETE FROM EST_HORA;
DELETE FROM EST_PRODUCTE;
DELETE FROM EST_VIRTUAL;
DELETE FROM VENTA;
DELETE FROM PRODUCTE;
DELETE FROM BOTIGA;
DELETE FROM CIUTAT;
DELETE FROM REGIO;

--Poblem la BDD amb ELS PRODUCTES, LES BOTIGUES, LES CIUTATS, I LES REGIONS
Insert into REGIO values ('2','Alt Empord');
Insert into REGIO values ('9','Baix Empord');
Insert into REGIO values ('10','Baix Llobregat');


Insert into CIUTAT values ('32','Calonge','9');
Insert into CIUTAT values ('50','Cornell de Llobregat','10');
Insert into CIUTAT values ('84','Llan','2');

BOTIGA_PKG.ALTA_BOTIGA (1,32,'conubia.nostra@Curabitur.ca',3,0,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (2,50,'eget@Nullam.org',2,1,0,p_RES,p_ERRDESC);
BOTIGA_PKG.ALTA_BOTIGA (5,84,'non.magna@Pellentesquehabitant.edu',5,0,1,p_RES,p_ERRDESC);

PRODUCTE_PKG.ALTA_PRODUCTE (8452113001221,'Chaqueta en color verde caki con forro acolchado de cuadros en medio cuerpo. Cuatro bolsillos delanteros. Cierre de cremallera. Bordado trasero.',
to_date('11/19/2009', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001207,'Pantaln tejano skinny en color azul marino. Tres bolsillos delanteros y dos traseros. Cierre de cremallera y botn.',
to_date('01/20/2010', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001016,'Falda tubo elstica en color negro. Ideal para todo tipo de looks, formales e informales.',
to_date('12/26/2012', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113000996,'Camiseta entallada de manga larga y cuello redondo con transparencia y print de cachemir.',
to_date('04/02/2013', 'MM/DD/YYYY'),p_RES,p_ERRDESC);
PRODUCTE_PKG.ALTA_PRODUCTE (8452113001115,'Jersey de punto gordo jaspeado en azul y blanco. Cuello de pico y manga larga.',
to_date('02/13/2014', 'MM/DD/YYYY'),p_RES,p_ERRDESC);

VENTA_PKG.ALTA_VENTA (1,8452113001221,'1/10/2015',10,1,59.99,21.99,p_RES,p_ERRDESC); --1
VENTA_PKG.ALTA_VENTA (1,8452113000996,'1/10/2015',10,1,15.95,10.05,p_RES,p_ERRDESC); --2
VENTA_PKG.ALTA_VENTA (2,8452113001207,'1/10/2015',14,1,69.99,30.10,p_RES,p_ERRDESC); --3
VENTA_PKG.ALTA_VENTA (2,8452113001016,'1/10/2015',15,1,35,15.50,p_RES,p_ERRDESC); --4
VENTA_PKG.ALTA_VENTA (5,8452113001115,'1/10/2015',20,1,40,25,p_RES,p_ERRDESC); --5
VENTA_PKG.ALTA_VENTA (5,8452113001221,'1/10/2015',23,1,59.99,18.75,p_RES,p_ERRDESC); --6
VENTA_PKG.ALTA_VENTA (1,8452113000996,'2/10/2015',13,2,30,20.10,p_RES,p_ERRDESC); --7
VENTA_PKG.ALTA_VENTA (1,8452113001207,'2/10/2015',14,1,69.99,25.95,p_RES,p_ERRDESC); --8
VENTA_PKG.ALTA_VENTA (2,8452113000996,'2/10/2015',15,1,15.95,9,p_RES,p_ERRDESC); --9
VENTA_PKG.ALTA_VENTA (1,8452113001115,'2/10/2015',15,2,80,43,p_RES,p_ERRDESC); --10
VENTA_PKG.ALTA_VENTA (2,8452113001207,'3/10/2015',16,1,69.99,23,p_RES,p_ERRDESC); --11
VENTA_PKG.ALTA_VENTA (2,8452113001221,'3/10/2015',17,1,59.99,30,p_RES,p_ERRDESC); --12
VENTA_PKG.ALTA_VENTA (1,8452113001115,'3/10/2015',17,1,40,23,p_RES,p_ERRDESC); --13
VENTA_PKG.ALTA_VENTA (2,8452113001016,'3/10/2015',18,1,35,16,p_RES,p_ERRDESC); --14
VENTA_PKG.ALTA_VENTA (5,8452113000996,'3/10/2015',18,2,15.95,11,p_RES,p_ERRDESC); --15
VENTA_PKG.ALTA_VENTA (1,8452113001115,'4/10/2015',18,1,40,20,p_RES,p_ERRDESC); --16
VENTA_PKG.ALTA_VENTA (1,8452113001207,'4/10/2015',19,1,69.99,25.5,p_RES,p_ERRDESC); --17
VENTA_PKG.ALTA_VENTA (5,8452113001016,'4/10/2015',19,1,35,18,p_RES,p_ERRDESC); --18
VENTA_PKG.ALTA_VENTA (2,8452113001221,'5/10/2015',20,1,59.99,22,p_RES,p_ERRDESC); --19
VENTA_PKG.ALTA_VENTA (5,8452113000996,'5/10/2015',3,1,14,9,p_RES,p_ERRDESC); --20


dbms_output.put_line('');
dbms_output.put_line('Provem les diferents consultes mensuals amb les dades que hem introdut:'); 
dbms_output.put_line('');
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_BOTIGA(2015,10);
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PRODUCTE(2015,10);
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PER_DIES(2015,10);  

dbms_output.put_line('');
dbms_output.put_line('Modifiquem les vendes i veiem com els valors canvien:'); 
dbms_output.put_line('');

VENTA_PKG.ALTA_VENTA (5,8452113001016,'3/10/2015',0,1,35,16,p_RES,p_ERRDESC); --21
VENTA_PKG.ALTA_VENTA (5,8452113000996,'3/10/2015',20,2,15.95,11,p_RES,p_ERRDESC); --22
VENTA_PKG.ALTA_VENTA (5,8452113001115,'4/10/2015',12,1,40,20,p_RES,p_ERRDESC); --23
VENTA_PKG.ALTA_VENTA (5,8452113001207,'4/10/2015',19,1,69.99,25.5,p_RES,p_ERRDESC); --24
VENTA_PKG.ALTA_VENTA (5,8452113001016,'4/10/2015',22,1,35,18,p_RES,p_ERRDESC); --25
VENTA_PKG.ALTA_VENTA (5,8452113001221,'5/10/2015',20,1,59.99,22,p_RES,p_ERRDESC); --26
VENTA_PKG.ALTA_VENTA (5,8452113000996,'5/10/2015',23,1,14,9,p_RES,p_ERRDESC); --27
VENTA_PKG.MODIFICAR_VENTA (2,8452113001207,'1/10/2015',14,2,139.98,60,p_RES,p_ERRDESC); --28
VENTA_PKG.MODIFICAR_VENTA (2,8452113000996,'2/10/2015',15,2,30,17,p_RES,p_ERRDESC); --29
VENTA_PKG.MODIFICAR_VENTA (2,8452113001016,'3/10/2015',18,2,70,31,p_RES,p_ERRDESC); --30

dbms_output.put_line('');
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_BOTIGA(2015,10);
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PRODUCTE(2015,10);
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PER_DIES(2015,10);
  
  
dbms_output.put_line('');
dbms_output.put_line('Provem les diferents situacions d'||chr(39)||'Error:'); 
dbms_output.put_line('');

--Format d'any incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_BOTIGA(15,1);
--Format de mes incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_BOTIGA(2015,0);
--No hi ha dades per l'any 2014
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_BOTIGA(2014,1);

--Format d'any incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PRODUCTE(15,1);
--Format de mes incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PRODUCTE(2015,0);
--No hi ha dades per l'any 2014
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PRODUCTE(2014,1);

--Format d'any incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PER_DIES(15,1);
--Format de mes incorrecte
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PER_DIES(2015,0);
--No hi ha dades per l'any 2014
CONSULTES_PKG.MOSTRAR_RESUM_MENSUAL_PER_DIES(2014,1);

--Tornem a activar els triggers
EXECUTE IMMEDIATE 'ALTER TRIGGER TRIGGER_VENTA_EST ENABLE';

end;